/*
 * JSON Stream Parser
 * Copyright 2010,2011 Joachim Lippold <mailToJoeAtIcq@icqmail.com>
 * 
 * This file is part of the JSON Stream Parser.
 *
 * JSON Stream Parser is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * JSON Stream Parser is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JSON Stream Parser.  If not, see <http://www.gnu.org/licenses/>.
 */

package l.joe.json;

/**
 * @author Joachim Lippold <mailToJoeAtIcq@icqmail.com>
 *
 */
public interface JSONHandler {

    void startObject();

    void endObject();

    void objectValueName(String valueName);

    void startArray();

    void endArray();

    void stringValue(String value);

    void numberValue(Number number);

    void booleanValue(boolean value);

    void nullValue();

}
