/*
 * Streamtastic Streamripper Frontend
 * Copyright 2008 Andreas Kuehntopf <andreas@kuehntopf.org>
 * 
 * This file is part of Streamtastic.
 *
 * Streamtastic is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Streamtastic is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Streamtastic.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.kuehntopf.streamtastic.gui.components;

import java.awt.Point;

import javax.swing.JPopupMenu;
import javax.swing.JTable;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;

/**
 * @author Joachim Lippold <mailToJoeAtIcq@icqmail.com>
 *
 */
public class StationPopupMenu extends JPopupMenu {

    /**
     * 
     */
    public StationPopupMenu()
    {
        this(null);
    }

    /**
     * @param label
     */
    public StationPopupMenu(String label)
    {
        super(label);

        this.addPopupMenuListener(new PopupMenuListener() {
            private int rowBefore = -1;
            private int colBefore = -1;
            
            public void popupMenuWillBecomeVisible(PopupMenuEvent e)
            {
                JPopupMenu menu = (JPopupMenu) e.getSource();
                if (! (menu.getInvoker() instanceof JTable) )
                    return;
                
                JTable table = (JTable) menu.getInvoker();
                if (table.isEditing()) 
                    table.getCellEditor().cancelCellEditing();
                Point mousePosition = table.getMousePosition();
                int row = table.rowAtPoint(mousePosition);
                int col = table.columnAtPoint(mousePosition);
                rowBefore = table.getSelectedRow();
                colBefore = table.getSelectedColumn();
                
                if (row != rowBefore || col != colBefore) 
                    table.changeSelection(row, col, false, false);
            }
            
            public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {}
            
            public void popupMenuCanceled(PopupMenuEvent e)
            {
                JPopupMenu menu = (JPopupMenu) e.getSource();
                if (! (menu.getInvoker() instanceof JTable) )
                    return;

                JTable table = (JTable) menu.getInvoker();
                
                if (rowBefore==-1) 
                    table.clearSelection();
                else
                    table.changeSelection(rowBefore, colBefore, false, false);
            }
        });
    }

}
